import arzumify.networked.api.Network;
import arzumify.networked.api.NetworkFactory;
import arzumify.networked.api.Node;
import arzumify.networked.impl.MatchMaker;
import arzumify.presence.maths.Vec3i;
import net.minecraft.util.math.BlockPos;

import java.util.HashMap;

public class CodeOnlyNetworkedBlock {
    public CodeOnlyNetworkedBlock(NetworkFactory factory) {
        this.factory = factory;
    }

    private final NetworkFactory factory;
    private final HashMap<BlockPos, Network> network = new HashMap<>();
    private final HashMap<BlockPos, Node> node = new HashMap<>();

    public void onStateReplaced(BlockPos pos) {
        System.out.println("Removing self");
        network.get(pos).Remove(node.get(pos));
    }

    public void onPlaced(BlockPos pos) {
        var presence = new Node(new Vec3i(pos.getX(), pos.getY(), pos.getZ()));
        node.put(pos, presence);
        var found = MatchMaker.matchMaker.Search(presence, MatchMaker.networkDiscovery);
        System.out.println(this);
        System.out.println(found);
        if (found != null && !found.isEmpty()) {
            Network previous = null;
            for (var basePresence : found) {
                if (basePresence instanceof Network foundNetwork) {
                    if (previous == null) {
                        foundNetwork.Add(presence);
                        this.network.put(pos, foundNetwork);
                    } else {
                        foundNetwork.Merge(previous);
                    }
                    previous = foundNetwork;
                }
            }
        } else {
            var network = factory.create();
            this.network.put(pos, network);
            network.Add(presence);
            MatchMaker.matchMaker.Add(network, MatchMaker.networkDiscovery);
        }
    }
}
