import arzumify.networked.impl.BasePresence;
import arzumify.networked.impl.MatchMaker;
import arzumify.presence.maths.Vec3i;
import net.minecraft.util.math.BlockPos;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class NetworkTests {
    private final CodeOnlyNetworkedBlock block = new CodeOnlyNetworkedBlock(ExampleNetwork::new);

    @BeforeEach
    public void Reset() {
        MatchMaker.matchMaker = new arzumify.presence.matchmaker.MatchMaker<>();
    }

    @Test
    public void NetworkCreationTest() {
        block.onPlaced(new BlockPos(0, 0, 0));
        var found = MatchMaker.matchMaker.Search(new BasePresence((short) 1, new Vec3i(0, 1, 0)), MatchMaker.networkDiscovery);
        assertEquals(1, found.size());
    }

    @Test
    public void NetworkSplitTest() {
        var centrePos = new BlockPos(0, 0, 0);
        block.onPlaced(centrePos);
        block.onPlaced(new BlockPos(0, 0, -1));
        block.onPlaced(new BlockPos(0, 0, 1));
        block.onPlaced(new BlockPos(0, 1, 0));
        block.onStateReplaced(centrePos);
        var found = MatchMaker.matchMaker.Search(new BasePresence((short) 1, new Vec3i(0, 0, 0)), MatchMaker.networkDiscovery);
        assertEquals(3, found.size());
    }
}
